﻿/*
** Lrc 歌词秀演示文档类
** 作者： Molay
** 版本： 1.0
** 修改时间： 2007-07-01
** 版权所有： Vnice's Group, Inc.
*/
package {
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.net.*;
	import flash.utils.*;
	import flash.media.*;
	
	import flash.geom.*;

	import Vnices.*;
	
	public class LrcDemo extends MovieClip {
		// 内部成员
		private var _mcBase, _lrcObj, _bmp1, _bar, _cur = 0, _Sound, _channel, _add;
		private var _lrcItem:Array = [];
		// 构造函数
		public function LrcDemo() {
			// 测试 - 装载歌词
			var xml_Loader:URLLoader = new URLLoader();
			xml_Loader.addEventListener(Event.COMPLETE, Xml_Loaded);
			xml_Loader.addEventListener(IOErrorEvent.IO_ERROR, Xml_Error);
			xml_Loader.load(new URLRequest("test.lrc"));
		}
		
		/********** XML监听部分 **********/
		private function Xml_Loaded(event:Event):void {
			var loader:URLLoader = URLLoader(event.target);
			ParseLrc(loader.data);
			PlaySound();
		}
		
		private function Xml_Error(event:IOErrorEvent):void {
			trace("文件载入出错......");
		}
		
		/********** 创建Lrc显示基础 **********/
		private function ParseLrc(str:String):void {
			_lrcObj = new Lrc(str);
			_bmp1 = new Sprite();
			for(var i in _lrcObj.msg){
				var tempDt:Number = 10;
				if(i<_lrcObj.msg.length-1){
					tempDt = _lrcObj.stime[i+1] -  _lrcObj.stime[i];
				}
				var tempMC:Sprite = new Sprite();
				var tempParam:Object = {text:_lrcObj.msg[i],dt:tempDt,standColor:0x800000,highColor:0xFFFFFF,bgColor:0xF58A43};
				var tempItem = new LrcShowItem(tempMC, tempParam);
				_lrcItem.push(tempItem);
				tempMC.x = Math.round((stage.stageWidth-tempItem.itemWidth)/2);
				tempMC.y = i*20;
				_bmp1.addChild(tempMC);
			}
			_bmp1.y = stage.stageHeight;
			addChild(_bmp1);
		}
		
		/********** 音频播放逻辑 **********/
		private function PlaySound():void {
			_Sound = new Sound();
			_Sound.addEventListener(ProgressEvent.PROGRESS, onSoundLoad);
			_Sound.addEventListener(Event.ID3, onSoundID3);
			_Sound.addEventListener(Event.COMPLETE, onComplete);
			_Sound.addEventListener(IOErrorEvent.IO_ERROR, onError);
			_Sound.load(new URLRequest("test.mp3"));
			_channel = _Sound.play();
			_channel.addEventListener(Event.SOUND_COMPLETE, TheEnd);
			// 
			var mp3_Timer:Timer = new Timer(1000/25);
			mp3_Timer.addEventListener(TimerEvent.TIMER, MoveLrc);
			mp3_Timer.start();
		}
		// 装载事件
		private function onSoundLoad(event:ProgressEvent):void {
			var p:Number=Math.floor(event.bytesLoaded * 100 / event.bytesTotal);
		}
		// ID3事件
		private function onSoundID3(event:Event):void {

		}
		// 显示MP3信息
		private function ShowID3():void {
			
		}
		// 完成事件
		private function onComplete(event:Event):void {
			
		}
		// 错误事件
		private function onError(event:IOErrorEvent):void {
			
		}
		// 播放完成
		private function TheEnd(event:Event):void {
			
		}
		private function MoveLrc(event:TimerEvent):void {
			if(_channel.position>=_lrcObj.stime[_cur]*1000){
				_cur++;
				_lrcItem[_cur-1].karaokIn();
				//_lrcItem[_cur-1].normalIn();
				if(_cur>1){
					_lrcItem[_cur-2].normalOut();
				}
			}
			if(_cur-1==0){
				_add = _lrcObj.stime[_cur];
				_bmp1.y += ((stage.stageHeight)/2 - 10 - (_cur)*20 - _bmp1.y)/(_add*10);
			}else if(_cur<_lrcObj.stime.length){
				_add = _lrcObj.stime[_cur] -  _lrcObj.stime[_cur-1];
				_bmp1.y += ((stage.stageHeight)/2 - 10 - (_cur)*20 - _bmp1.y)/(_add*40);
			}else{
				_bmp1.y += -0.1;
			}
		}
	}
}