﻿/*
** Vnice's 歌词文件处理类
** 作者： Molay
** 版本： 2.0
** 修改时间： 2007-11-24
** 版权所有： Vnice's Group, Inc.
*/
package Vnices{
	public class Lrc extends Object {
		// 只读私有成员
		private var _lrcObj:Object;
		public function get head():Object {
			return _lrcObj.head;
		}
		public function get stime():Object {
			return _lrcObj.stime;
		}
		public function get msg():Object {
			return _lrcObj.msg;
		}
		// 构造函数
		public function Lrc(lrcData:String):void {
			// 初始化歌词Object
			_lrcObj = new Object();
			// 预处理LRC文件体，剔除全部无用空白字符
			//lrcData = lrcData.replace(new RegExp("[\\f\\n\\r\\t\\v]","g"),"");
			lrcData = lrcData.replace(new RegExp("[\\f\\r\\t]","g")," ");
			Parse(lrcData);
		}
		// 解释LRC文件为数组
		private function Parse(lrcData:String):void {
			// 临时歌词Object
			var lrcTemp:Object = {};
			lrcTemp.head = {};
			lrcTemp.stime = [];
			lrcTemp.msg = [];
			// 获取元数据以及歌词数据临时数组
			var tempHead:Array = lrcData.match(new RegExp("\\[[a-z]{1,}:[^\\]]*\\]","gi"));
			var tempBody:Array = lrcData.match(new RegExp("(?:\\[[:\\.\\d]+\])+[^\\[]+","gi"));
			var item, itemTemp;
			// 填充元数据
			for(item in tempHead){
				itemTemp = tempHead[item].split(new RegExp("(?:\\[)([a-z]{1,}):([^\\]]*)(?:\\])","gi"));
				lrcTemp.head[itemTemp[1].toLowerCase()] = itemTemp[2];
			}
			// 填充歌词数据
			var notZero:Boolean = true;
			for(item in tempBody){
				itemTemp = tempBody[item].split(new RegExp("((?:\\[[:\\.\\d]+\\])+)([^\\[]+)","gi"));
				// 时间部分
				var stimeTemp:Array = itemTemp[1].match(new RegExp("[:\\.\\d]+","gi"));
				for(var st in stimeTemp){
					lrcTemp.stime.push(Time2Ten(stimeTemp[st]));
					lrcTemp.msg.push(itemTemp[2]);
					if(Time2Ten(stimeTemp[st])==0){
						notZero = false;
					}
				}
			}
			// 如果没有[00:00.00]时间头，就自动加上
			if(notZero){
				lrcTemp.stime.push(0);
				lrcTemp.msg.push("Molay's Lrc V2.0");
			}
			// 重新排列数组
			lrcTemp = Order(lrcTemp);
			// 返回LRC
			_lrcObj = lrcTemp;
		}
		// 将60进制的时间String转换为10进制Number
		private function Time2Ten(str:String):Number {
			var temp:Number = 0;
			var tempArray:Array = str.split(":");
			tempArray.reverse();
			for(var i in tempArray){
				temp += tempArray[i]*Math.pow(60,i);
			}
			return temp;
		}
		// 歌词数组排序，此处采用的是简单的冒泡算法
		private function Order(lrcTemp:Object){
			var a:Array = lrcTemp.stime;
			var b:Array = lrcTemp.msg;
			var temp, n = a.length;
			for(var i in a){
				var min:Number = i;
				for (var j = i + 1; j < n + 1; j++) {
					if (a[min] > a[j]) {
						min = j;
					}
				}
				// 由小到大排列stime
				temp = a[i];
				a[i] = a[min];
				a[min] = temp;
				// 依照stime顺序排列歌词
				temp = b[i];
				b[i] = b[min];
				b[min] = temp;
			}
			return lrcTemp;
		}
	}
}