﻿/*
** Vnice's 歌词显示元
** 作者： Molay
** 版本： 2.0
** 修改时间： 2007-11-24
** 版权所有： Vnice's Group, Inc.
*/
package Vnices{
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.utils.*;
	
	import Vnices.*;
	
	public class LrcShowItem extends MovieClip {
		// 内部成员
		private var _mcBase:Sprite, _param:Object, _status:String;
		private var _mcBot:Sprite, _mcTop:Sprite, _mcMask:Sprite;
		private var _timerIn:Timer, _timerOut:Timer; 
		
		// 只读属性
		public function get itemWidth():Number {
			return _mcBot.width;
		}
		
		// 构造函数
		public function LrcShowItem(mc:Sprite, param:Object):void {
			// 初始化内部成员
			_mcBase = mc;
			_param = param;
			_status = "";
			_mcBot = new Sprite();
			_mcTop = new Sprite();
			_mcMask = new Sprite();
			// 创建
			createMC();
		}
		
		// 创建显示元件
		private function createMC():void {
			// 声明局部变量
			var tempFormat:TextFormat, tempBitmapData:BitmapData, tempBitmap:Bitmap;
			var textBot:TextField, textTop:TextField;
			// 全局样式
			tempFormat = new TextFormat();
			tempFormat.align = TextFormatAlign.CENTER;
			tempFormat.font = "宋体";
			// 创建正常态文字
			textBot = new TextField();
			textBot.width = FunString.strLength(_param.text);
			textBot.height = 20;
			textBot.text = _param.text;
			textBot.textColor = _param.standColor;
			textBot.setTextFormat(tempFormat);
			tempBitmapData = new BitmapData(textBot.width, textBot.height, true , _param.bgColor);
			tempBitmapData.draw(textBot);
			tempBitmap = new Bitmap(tempBitmapData);
			_mcBot.addChild(tempBitmap);
			// 创建高亮态文字
			textTop = new TextField();
			textTop.width = FunString.strLength(_param.text);
			textTop.height = 20;
			textTop.text = _param.text;
			textTop.textColor = _param.highColor;
			textTop.setTextFormat(tempFormat);
			tempBitmapData = new BitmapData(textTop.width, textTop.height, true , _param.bgColor);
			tempBitmapData.draw(textTop);
			tempBitmap = new Bitmap(tempBitmapData);
			_mcTop.addChild(tempBitmap);
			// 创建高亮遮罩
			Objects.drawRectangle(_mcMask, textTop.width, textTop.height, 0x000000, 100, undefined, undefined, undefined);
			_mcMask.x = - _mcMask.width;
			_mcTop.mask = _mcMask;
			// 显示
			_mcBase.addChild(_mcBot);
			_mcBase.addChild(_mcTop);
			_mcBase.addChild(_mcMask);
		}
		
		/********** 显示控制 **********/
		// 卡拉OK扫入
		public function karaokIn():void {
			_mcMask.x = -_mcMask.width;
			_timerIn = new Timer(100);
			_timerIn.addEventListener(TimerEvent.TIMER, karaokIn_EnterFarme);
			_timerIn.start();
		}
		private function karaokIn_EnterFarme(event:Event):void {
			//trace("卡拉OK扫入 : "+_mcMask.x);
			_mcMask.x += _mcTop.width/(_param.dt*10);
			if(_mcMask.x>=0){
				_mcMask.x = 0;
				_timerIn.stop();
				_timerIn.removeEventListener(TimerEvent.TIMER, karaokIn_EnterFarme);
			}
		}
		
		// 通常模式渐入
		public function normalIn():void {
			_mcTop.alpha = 0;
			_mcMask.x = 0;
			_timerIn = new Timer(100);
			_timerIn.addEventListener(TimerEvent.TIMER, normalIn_EnterFarme);
			_timerIn.start();
		}
		private function normalIn_EnterFarme(event:Event):void {
			//trace("通常模式渐入 : "+_mcTop.alpha);
			_mcTop.alpha += 1/10;
			if(_mcTop.alpha>=1){
				_mcTop.alpha = 1;
				_timerIn.stop();
				_timerIn.removeEventListener(TimerEvent.TIMER, normalIn_EnterFarme);
			}
		}
		
		// 通常模式渐出
		public function normalOut():void {
			if(_timerIn.running){
				//_timerIn.stop();
			}
			_timerOut = new Timer(100);
			_timerOut.addEventListener(TimerEvent.TIMER, normalOut_EnterFarme);
			_timerOut.start();
		}
		private function normalOut_EnterFarme(event:Event):void {
			//trace("通常模式渐出 : "+_mcTop.alpha);
			_mcTop.alpha -= 1/10;
			if(_mcTop.alpha<=0){
				_timerOut.stop();
				_timerOut.removeEventListener(TimerEvent.TIMER, normalOut_EnterFarme);
			}
		}
	}
}